
# Harness Resource Provider

The Harness resource provider for Pulumi lets you create resources in [Harness](https://www.harness.io). To use
this package, please [install the Pulumi CLI first](https://pulumi.com/).

## Installing

This package is available in many languages in standard packaging formats.

### Node.js (Java/TypeScript)

To use from JavaScript or TypeScript in Node.js, install using either `npm`:

```
$ npm install @pulumi/harness
```

or `yarn`:

```
$ yarn add @pulumi/harness
```

### Python

To use from Python, install using `pip`:

```
$ pip install pulumi-harness
```

### Go

To use from Go, use `go get` to grab the latest version of the library

```
$ go get github.com/pulumi/pulumi-harness/sdk/go/...
```

### .NET

To use from Dotnet, use `dotnet add package` to install into your project. You must specify the version if it is a pre-release version.


```
$ dotnet add package Pulumi.Harness
```

## Reference

See the Pulumi registry for API docs:

https://www.pulumi.com/registry/packages/Harness/api-docs/
